<?php
declare(strict_types=1);

namespace GamesShop\Routing;

use GamesShop\ContainerHandler;
use GamesShop\Environment\EnvironmentHandler;
use GamesShop\Templates\TemplateEngine;
use Laminas\Diactoros\Response;
use Psr\Http\Message\ServerRequestInterface;

final class LoginRoutes
{
    public function login(ServerRequestInterface $request) {
        $discordEnv = ContainerHandler::get(EnvironmentHandler::class)->getDiscordEnvironment();
        $pageContent = ContainerHandler::get(TemplateEngine::class)->renderPage(
            'login',
            [
                'discordUrl' => $discordEnv->loginUrl
            ]
        );

        $response = new Response;
        $response->getBody()->write($pageContent);
        return $response;
    }

    public static function addRoutes(\League\Route\Router $router): void {
        $routes = ContainerHandler::get(LoginRoutes::class);

        $router->get('/login', $routes->login(...));
    }
}